package ladasha.statistics;

import java.util.*;

public class DiscreteRNG {

	ArrayList<Double> probability;
	ArrayList<Double> distribution;

	public DiscreteRNG(ArrayList<Double> probability, ArrayList<Double> distribution) {
		this.probability = probability;
		this.distribution = distribution;
	}

	public double next() {
		Random r = new Random();
		double temp = r.nextDouble();
		for(Double d : probability) {
			if (temp <= probability.get(probability.indexOf(d))/1.0) {
				temp = distribution.get(probability.indexOf(d));
				break;
			}
		}
		return temp;
	}
}

class DiscreteTester {

	static DiscreteRNG d;
	static ArrayList<Double> probability = new ArrayList<Double>();
	static ArrayList<Double> distribution = new ArrayList<Double>();
	static Scanner sc = new Scanner(System.in);

	static void prompt() {
		System.out.print("Next distribution >");
		double t = sc.nextDouble();
		distribution.add(t);
		System.out.print("Probability >");
		t = sc.nextDouble() + (probability.isEmpty() ? 0 : probability.get(probability.size()-1));
		probability.add(t);
		if (probability.get(probability.size()-1) == 1.0) {
			d = new DiscreteRNG(probability,distribution);
			return;
		} else if (probability.get(probability.size()-1) > 1.0) {
			System.out.println("Probabilities are greater than 100%... restarting");
			probability.clear();
			distribution.clear();
			prompt();
		} else prompt();
	}

	static void shoot() {
		for (int i = 0; i < 20; i++)
			System.out.println(d.next());
	}
			

	public static void main(String[] args) {
		prompt();
		shoot();
	}
}	
